SystemOrganization addCategory: #'Stack-Exercise'!

Object subclass: #NodeStack
	instanceVariableNames: 'value prev'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!NodeStack class methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/6/2013 21:04'!
newWith: anObject withPrev: aNodeStack 

	|aNewNodeStack|

	 aNewNodeStack := self new.
	^aNewNodeStack initializeWith: anObject withPrev: aNodeStack. ! !

!NodeStack methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/6/2013 20:47'!
initializeWith: anObject withPrev: aNodeStack 

	prev := aNodeStack.
	value := anObject.! !

!NodeStack methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/6/2013 20:43'!
prev

	^prev.! !

!NodeStack methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/6/2013 21:09'!
signalIfEmpty
  
   ! !

!NodeStack methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/6/2013 21:05'!
value 

	^value.! !

Object subclass: #NodeStackNull
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!NodeStackNull methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/6/2013 21:09'!
signalIfEmpty

	| anError |
	anError := CollectionIsEmpty new.
	anError signal: OOStack stackEmptyErrorDescription. ! !

Object subclass: #OOStack
	instanceVariableNames: 'top size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStack class methodsFor: 'error descriptions' stamp: 'PabloRago 5/6/2013 20:15'!
stackEmptyErrorDescription

	^ 'lala pokemon'.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/6/2013 21:07'!
initialize 

	top := NodeStackNull new.
	size := 0.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/6/2013 21:06'!
isEmpty

	^ size = 0.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/6/2013 21:09'!
pop

	|anElement|
	
	top signalIfEmpty.
	anElement := top.
	top := anElement prev.
	size := size - 1.
	^anElement value.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/6/2013 21:06'!
push: anObject 

	| anElement |
	anElement := NodeStack newWith:anObject withPrev:top.
	top := anElement.
	size := size + 1.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/6/2013 21:06'!
size

	^size.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/6/2013 21:09'!
top
	
	top signalIfEmpty.
	^top value.! !

TestCase subclass: #OOStackTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test01StackShouldBeEmptyWhenCreated

	| stack |
	
	stack := OOStack new.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test02PushAddElementsToTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	
	self deny: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:31'!
test03PopRemovesElementsFromTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	stack pop.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/8/2012 08:20'!
test04PopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	stack push: pushedObject.
	
	self assert: stack pop = pushedObject! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:33'!
test05StackBehavesLIFO

	| stack firstPushedObject secondPushedObject |
	
	stack := OOStack new.
	firstPushedObject := 'First'.
	secondPushedObject := 'Second'.
	
	stack push: firstPushedObject.
	stack push: secondPushedObject.
	
	self assert: stack pop = secondPushedObject.
	self assert: stack pop = firstPushedObject.
	self assert: stack isEmpty 
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:35'!
test06TopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack top = pushedObject.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:36'!
test07TopDoesNotRemoveObjectFromStack

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack size = 1.
	stack top.
	self assert: stack size = 1.
	! !

!OOStackTest methodsFor: 'test' stamp: 'PabloRago 5/6/2013 20:09'!
test08CanNotPopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack pop ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/16/2012 16:53'!
test09CanNotPopWhenThereAreNoObjectsInTheStackAndTheStackHadObjects

	| stack  |
	
	stack := OOStack new.
	stack push: 'Something'.
	stack pop.
	
	self
		should: [ stack pop ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/16/2012 16:53'!
test10CanNotTopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack top ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !
